var $VERSION$="1.0";
/*global function $ serial*/
function $(id){return document.getElementById(id);}
function $$(a){return (typeof a).toLowerCase()=="object"?a:$(a);}
function $F(fl,digit){return Math.floor(fl*Math.pow(10,digit))/Math.floor(Math.pow(10,digit));}
function $P(i){return parseInt(i);}
function $T(s){return s.replace(/^\s+|\s+$/,"");}
function $W(str){document.write(str);}
function $R2(_n){return Math.floor(Math.random()*_n);}
function $Y(obj){
	var ot=(typeof obj).lc();
	if(ot=="object"){
		if(obj){
			if(obj.length!==undefined){
				ot="array";
			}
		}else{
			ot="null";
		}
	}
	return ot;
}
var $YCN={
	"object":"",
	"function":"",
	"array":"",
	"string":"ַ",
	"number":"",
	"boolean":"ֵ",
	"undefined":"δ"
};
function $R(_n,type){
	var c={n:"0123456789",s:"abcdefghijklmnopqrstuvwxyz",b:"ABCDEFGHIJKLMNOPQRSTUVWXYZ",c:"!@#$%^&*()_+\\][}{:;'\",./?><~`"};
    var r=a="";
    if(type){
		type=type.split("");
		for(var i=0;i<type.length;i++){
			a+=c[type[i]];
		}
    }else{a=c.n+c.s+c.b;}
	for(var i=0;i<_n;i++){r+=a.charAt($R2(a.length));}
    return r;
}
/*Window Operation*/
var Win={
	params:function(param,value){
		if(value||value===0){
			external[param]=value;
		}else{
			return external[param];
		}
	},
	top:function(value){
		this.params("top",value);
	},
	left:function(value){
		this.params("left",value);
	},
	width:function(value){
		this.params("width",value);
	},
	height:function(value){
		this.params("height",value);
	},
	caption:function(value){
		this.params("caption",value);
	},
	version:function(){
		var tmp=navigator.appVersion;
		if(tmp.indexOf("MSIE 8.0")>-1){
			return 8;
		}else if(tmp.indexOf("MSIE 7.0")>-1){
			return 7;
		}else if(tmp.indexOf("MSIE 6.0")>-1){
			return 6;
		}else{
			return 5;
		}
	},
	sysversion:function(){
		var tmp=navigator.userAgent;
		if(tmp.indexOf("Windows NT 7")>-1){
			return 7;
		}else if(tmp.indexOf("Windows NT 6")>-1){
			return 6;
		}else if(tmp.indexOf("Windows NT 5")>-1){
			return 5;
		}else{
			return 4;
		}
	},
	obj:function(s){
		/*
			s=Win.com
		*/
		return external.ActiveXObject(s);
	},
	com:{
		FSO:"Scripting.FileSystemObject",
		WSH:"WScript.Shell",
		CON:"Adodb.Connection",
		RDS:"Adodb.Recordset",
		SHA:"Shell.Application",
		STM:"Adodb.Stream"
	},
	exe:function(){
		return external.exeName;
	},
	exeScript:function(p1,p2,p3){
		external.exeScript(p1,p2,!!p3);
	},
	activate:function(){
		external.activate();
	},
	fullscreen:function(){
		external.fullscreen();
	},
	center:function(){
		external.center();
	},
	close:function(){
		external.close();
	},
	move:function(xdis,ydis){
		external.move(xdis,ydis);
	},
	moveTo:function(x,y){
		external.moveTo(x,y);
	},
	resizeTo:function(w,h){
		external.resizeTo(w,h);
	},
	border:function(p1,p2,p3){
		/*
			borderstyle:  
								0		|	none
								1		|	single
								2		|	resizeable
								3		|	dialog
								4		|	toolwindow, noresizable
								5		|	toolwindow,resizeable
			borderwidth,
			3d?
		*/
		return external.setBorder(p1,p2,!!p3);
	},
	corner:function(p1,p2){
		/*corner width, corner height*/
		external.setCorner(p1,p2);
	},
	status:function(p1){
		/*"min" , "max", "normal","hide","show"*/
		external.setStatus(p1);
	},
	toggle:function(height){
		(external.fold(parseInt(height))||external.fold());
	},
	redirect:function(from,to,cookiebool){
		external.setRedirect(from,to,!!cookiebool);
	},
	gradient:function(param){
		if(!param){param={};}
		if(param["from"]||param["from"]===0){param["from"]=param["from"]/100*255;}
		if(param["to"]||param["to"]===0){param["to"]=param["to"]/100*255;}
		var from=param["from"]===0?0:(param["from"]||external.alpha||255);
		var step=param["step"]||10;
		var to=param["to"]===0?0:(param["to"]||0);
		var interval=param["interval"]===0?0:(param["interval"]||100);
		var sign=from>to?-1:1;
		external.alpha=from;
		Dom.Timer.start(function(){
			var tmp=external.alpha+sign*step;
			if(tmp>255){tmp=255;}
			if(tmp<0){tmp=0;}
			external.alpha=tmp;
		},interval,function(){
			var alpha=external.alpha;
			return sign<0?(alpha<=to):(alpha>=to);
		});
	},
	restart:function(){
		external.alpha=0;
		this.resizeTo(0,0);
		Sys.CMD.open();
		Sys.CMD.run(this.exe());
		Sys.CMD.close();
		Win.close();
	},
	Dialog:{
		open:function(s1,s2,s3){
			/*title, ext , default directory*/
			return external.openFile(s1,s2,s3);
		},
		save:function(s1,s2,s3){
			/*title, ext , default directory*/
			return external.saveFile(s1,s2,s3);
		}
	},
	Drag:{
		item:[],
		set:function(item){
			var tp=(typeof item).toLowerCase();
			var items=[];
			if(tp == "string" || tp == "object"){
				items.push(item);
			}else{
				items=item||this.item;
			}
			for(var i=0,l=items.length;i<l;i++){
				var tmp=$$(items[i]);
				if(tmp){
					with(tmp){
						style.cursor="pointer";
						onmousedown=this.mouseDown;
						onmouseup=this.mouseUp;
						onmousemove=this.mouseMove;
					}
				}
			}
		},
		mouseDown:function(){
			if(event.button==1){
				external.dragDown();
			}
		},
		mouseUp:function(){
			external.dragUp();
		},
		mouseMove:function(){
			external.dragMove();
		}
	},
	Tray:{
		root:external.path,
		add:function(path,abs){
			external.addTrayIcon(abs?path:this.root+path);
		},
		start:function(showIcon,showIndex,showTurn,showInterval){
			/*showIcon?   showIndex,  in turn ?  time interval*/
			external.trayIcon(!!showIcon,showIndex,!!showTurn,showInterval);
		}
	},
	Clipboard:{
		copy:function(str){
			window.clipboardData.setData("text",str);
		},
		data:function(){
			return window.clipboardData.getData("text");
		}
	},
	Screen:screen,
	Color:{
		obj:{
			"aqua":"#00FFFF",
			"black":"#000000",
			"blue":"#0000ff",
			"fuchsia":"#FF00FF",
			"gray":"#808080",
			"green":"#008000",
			"lime":"#00FF00",
			"maroon":"#800000",
			"navy":"#000080",
			"olive":"#808000",
			"purple":"#800080",
			"red":"#FF0000",
			"silver":"#C0C0C0",
			"teal":"#008080",
			"white":"#FFFFFF",
			"yellow":"#FFFF00"
		},
		cn:{
			"aqua":"%E6%B5%85%E7%BB%BF",
			"black":"%E9%BB%91%E8%89%B2",
			"blue":"%E7%99%BD%E8%89%B2",
			"fuchsia":"%E7%B4%AB%E7%BA%A2",
			"gray":"%E7%81%B0%E8%89%B2",
			"green":"%E7%BB%BF%E8%89%B2",
			"lime":"%E4%BA%AE%E7%BB%BF",
			"maroon":"%E8%A4%90%E7%BA%A2",
			"navy":"%E5%A4%A9%E8%93%9D",
			"olive":"%E6%A9%84%E6%A6%84",
			"purple":"%E7%B4%AB%E8%89%B2",
			"red":"%E7%BA%A2%E8%89%B2",
			"silver":"%E9%93%B6%E8%89%B2",
			"teal":"%E9%9D%92%E8%89%B2",
			"white":"%E7%99%BD%E8%89%B2",
			"yellow":"%E9%BB%84%E8%89%B2"
		},
		options:function(type){
			var str="";
			for(var i in this.obj){
				str+="<option value='"+this.obj[i]+"'>"+(type=="cn"?decodeURI(this.cn[i]):i)+"</option>";
			}
			return str;
		},
		control:function(id,type){
			var str="<select id='"+id+"'>";
			for(var i in this.obj){
				str+="<option value='"+this.obj[i]+"'>"+(type=="cn"?decodeURI(this.cn[i]):i)+"</option>";
			}
			str+="</select>";
			return str;
		}
	}
};

/*File Operation*/
var File={
	filearray:{},
	root:external.path,
	absolutePath:false,
	list:function(param){
		var c=[];
		for(var i in this.filearray){
			(!param||param=="handle")?c.push(i):c.push(this.filearray[i]);
		}
		return c;
	},
	count:function(){
		return this.list().length;
	},
	open:function(filename){
		var fileno=$R(16);
		this.filearray[fileno]=this.absolutePath?(this.root+filename):filename;
		return fileno;
	},
	read:function(fileno){
		var FSO=Win.obj(Win.com.FSO);
		var filepath=this.filearray[fileno];
		if(FSO.FileExists(filepath)){
			FSO=null;
			return (external.readData(filepath));
		}else{
			FSO=null;
			return false;
		}
	},
	write:function(fileno/*file Handle*/,content/*data be written*/,create/*if not exist then create?*/){
		var FSO=Win.obj(Win.com.FSO);
		var filepath=this.filearray[fileno];
		if(create!==false||FSO.FileExists(filepath)){
			FSO=null;
			external.writeData(filepath,content);
			return true;
		}else{
			FSO=null;
			return false;
		}
	},
	append:function(fileno,content){
		var FSO=Win.obj(Win.com.FSO);
		var filepath=this.filearray[fileno];
		if(FSO.FileExists(filepath)){
			var tmp=FSO.openTextFile(filepath,8,true);
			tmp.write(content);
			tmp.close();
			FSO=null;
			return true;
		}else{
			FSO=null;
			return false;
		}
	},
	close:function(fileno){
		delete this.filearray[fileno];
	},
	copy:function(from,to,overwrite){
		try{
			var FSO=Win.obj(Win.com.FSO);
			FSO.CopyFile(from,to,overwrite);
			FSO=null;
			return true;
		}catch(e){
			return false;
		}
	},
	del:function(file,force){
		try{
			var FSO=Win.obj(Win.com.FSO);
			FSO.DeleteFile(file,force);
			FSO=null;
			return true;
		}catch(e){
			return false;
		}
	},
	rename:function(oldfile,newfile,overwrite){
		try{
			this.copy(oldfile,newfile,overwrite);
			this.del(oldfile);
			return true;
		}catch(e){
			return false;
		}
	},
	exists:function(file){
		try{
			var FSO=Win.obj(Win.com.FSO);
			var fe=FSO.FileExists(file);
			FSO=null;
			return fe;
		}catch(e){
			return false;
		}
	},
	ext:function(path){
		var fullname=this.filefullname(path);
		if(fullname.lastIndexOf(".")==-1){
			return "";
		}else{
			return fullname.substring(fullname.lastIndexOf(".")+1,fullname.length);
		}
	},
	filename:function(path){
		var fullname=this.filefullname(path);
		if(fullname.lastIndexOf(".")==-1){
			return fullname;
		}else{
			return fullname.substring(0,fullname.lastIndexOf("."));
		}
	},
	path:function(path){
		return path.substring(0,path.lastIndexOf("\\")+1);
	},
	filefullname:function(path){
		return path.substring(path.lastIndexOf("\\")+1,path.length);
	}
};
var Dir={
	add:function(dir){
		try{
			var FSO=Win.obj(Win.com.FSO);
			FSO.CreateFolder(dir);
			FSO=null;
			return true;
		}catch(e){
			return false;
		}
	},
	del:function(dir,force){
		try{
			var FSO=Win.obj(Win.com.FSO);
			FSO.DeleteFolder(dir,force);
			FSO=null;
			return true;
		}catch(e){
			return false;
		}
	},
	copyAll:function(from,to,overwrite){
		try{
			File.copy(from+"*",to,overwrite);
			this.copy(from+"*",to,overwrite);
			var FSO=Win.obj(Win.com.FSO);
			var f=FSO.GetFolder(from);;
			var fc=new Enumerator(f.SubFolders);
			for (; !fc.atEnd(); fc.moveNext()){
				  var path=fc.Path;
				  if(path.subString(path.length-1,path.length)!="\\"){
					path+="\\";
				  }
				  var nosPath=path.replace(/\\\\$/);
				  var dirname=nosPath.substring(nosPath.lastIndexOf("\\")+1,nosPath.length);
				  this.copyAll(path,to+dirname+"\\");
			}
			fc=null;
			f=null;
			FSO=null;
			return true;
		}catch(e){
			return false;
		}
	},
	copy:function(from,to,overwrite){
		try{
			var FSO=Win.obj(Win.com.FSO);
			FSO.CopyFolder(from,to,overwrite);
			FSO=null;
			return true;
		}catch(e){
			return false;
		}
	},
	exists:function(file){
		try{
			var FSO=Win.obj(Win.com.FSO);
			var fe=FSO.FolderExists(file);
			FSO=null;
			return fe;
		}catch(e){
			return false;
		}
	}
};	
/*Stream Operation*/
var Stream={
	load:function(filepath){
		var obj=Win.obj(Win.com.STM);
		obj.Type=1
		obj.open();
		obj.loadFromFile(filepath);
		var rs=obj.read();
		obj.close();
		obj=null;
		return rs;
	},
	text:function(stream,charset){
		charset=(charset||"utf-8").toLowerCase();
		var obj=Win.obj(Win.com.STM);
		obj.Mode=3;obj.Type=2;
		obj.open();
		obj.writeText(stream);
		obj.position=0;
		obj.Charset=charset;
		obj.position=2;
		var rval=obj.readText();
		obj.close();
		obj=null;
		return rval;
	},
	save:function(filepath,stream,charset){	
		charset=(charset||"utf-8").toLowerCase();
		var obj=Win.obj(Win.com.STM);
		obj.Mode=3;obj.Type=2;
		obj.open();
		obj.writeText(stream);
		obj.position=0;
		obj.Charset=charset;
		obj.position=2;
		obj.saveToFile(filepath,2);
		obj.close();
		obj=null;
	},
	saveImage:function(filepath,stream){
		var obj=Win.obj(Win.com.STM);
		obj.Type=1;
		obj.open();
		obj.write(stream);
		obj.saveToFile(filepath,2);
		obj.close();
		obj=null;
	}
};
/*Dir Operation*/

/*Ini Operation*/
var Ini={
	select:null,
	selectid:"",
	iniarray:{},
	load:function(filename){
		var tmp=File.open(filename);
		var c=File.read(tmp);
		if(!c){
			this.iniarray[tmp]={};
		}else{
			try{
				this.iniarray[tmp]=eval("("+c+")");
			}catch(e){
				alert("load ini error[filename:"+filename+"]");
				return false;
			}
		}
		this.selectIni(tmp);
		return tmp;
	},
	addA:function(sectionName,SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		if(iniObj){
			iniObj[sectionName]={};
		}else{
			alert("Maybe you have not loaded the ini file");
		}
	},
	delA:function(sectionName,SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		if(iniObj){
			delete iniObj[sectionName];
		}else{
			alert("Maybe you have not loaded the ini file");
		}
	},
	addB:function(sectionName,name,value,SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		if(iniObj){
			if(!iniObj[sectionName]){iniObj[sectionName]={};}
			iniObj[sectionName][name]=value;
		}else{
			alert("Maybe you have not loaded the ini file");
		}
	},
	delB:function(sectionName,name,SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		if(iniObj){
			if(!iniObj[sectionName]){return;}
			delete iniObj[sectionName][name];
		}else{
			alert("Maybe you have not loaded the ini file");
		}
	},
	obj:function(SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		return iniObj;
	},
	selectIni:function(SELECT){
		if(SELECT){
			this.select=this.iniarray[SELECT];
			if(!this.select){
				alert("Maybe you have not loaded the ini file");
				return false;
			}
			this.selectid=SELECT;
		}else{
			return this.selectid;
		}
	},
	saveTo:function(filename){
		var PRIINI=this.selectIni();
		var TMPOBJ=this.obj();
		var TMPINI=this.load(filename);
		this.saveObj(TMPOBJ,TMPINI);
		this.selectIni(PRIINI);
		this.unload(TMPINI);
	},
	saveObj:function(obj,SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		if(iniObj){
			File.write(SELECT||this.selectid,this.obj2str(obj),true);
		}else{
			alert("Maybe you have not loaded the ini file");
		}
	},
	save:function(SELECT){
		var iniObj=(SELECT&&this.iniarray[SELECT])||this.select||null;
		if(iniObj){
			File.write(SELECT||this.selectid,this.obj2str(iniObj),true);
		}else{
			alert("Maybe you have not loaded the ini file");
		}
	},
	unload:function(SELECT){
		var tmp=SELECT||this.selectIni();
		File.close(tmp);
		delete this.iniarray[tmp];
	},
	obj2str:function(iniObj){
		var str="{";
		for(var i in iniObj){
			str+="\""+i+"\":{";
			for(var j in iniObj[i]){
				str+="\""+j+"\":";
				var tmp=iniObj[i][j];
				switch((typeof tmp).toLowerCase()){
					case "boolean":
						str+=tmp.toString()+",";break;
					case "number":
						str+=tmp+",";break;
					case "object":
					case "function":
					case "undefined":
						break;
					case "string":
						str+="\""+tmp.replace(/([\\"])/g,function($1){
							return "\\"+$1;
						})+"\",";break;
				}
			}
			(str.lastIndexOf(",")==str.length-1)&&(str=str.substring(0,str.length-1));
			str+="},"
		}
		(str.lastIndexOf(",")==str.length-1)&&(str=str.substring(0,str.length-1));
		str+="}";
		return str;
	}
};
/*Sys Operation*/
var Sys={
	CMD:{
		obj:null,
		init:function(){
			try{
				this.obj=Win.obj(Win.com.WSH);
			}catch(e){
				alert("Create WScript.shell Object Error");
			}
		},
		open:function(){
			this.init();
		},
		TMP:{
			cmdtmp:"lib\\cmd.tmp"
		},
		run:function(path,rs,wait){
			if(this.obj){
				if(rs){
					var cmd="cmd /c "+path+" > \""+external.path+this.TMP.cmdtmp+"\"";
					Win.Clipboard.copy(cmd);
					this.obj.run(cmd,0,true);
					var tmp=File.open(this.TMP.cmdtmp);
					var rs=File.read(tmp);
					File.close(tmp);
					return rs;
				}else{
					this.obj.run("cmd /c "+path,0,wait);
				}
			}
		},
		exec:function(path){
			if(this.obj){
				var oe=this.obj.exec(path);
				return oe.stdout.ReadAll()||true;
			}
		},
		com:function(path,abs){
			path=abs?path:(external.path+path);
			var rs=this.run("regsvr32 /s \""+path+"\"",false,true);
			return path;			
		},
		uncom:function(path,abs){
			path=abs?path:(external.path+path);
			var rs=this.run("regsvr32 /s /u \""+path+"\"",false,true);	
			return path;		
		},
		close:function(){
			this.obj=null;
		}
	},
	Disk:{
		obj:null,
		init:function(){
			try{
				this.obj=Win.obj(Win.com.FSO);
			}catch(e){
				alert("Create Scripting.FileSystemObject Object Error");
			}
		},
		open:function(){
			this.init();
		},
		close:function(){
			this.obj=null;
		},
		control:function(id,template){
			var temptag=template||"{name} ({id}:)";
			/*
				template:
					{name}		Drive Volume Name
					{id}			Drive Letter
					{type}		Drive Type
					{total:GB/MB/KB/B}		Drive Total Size
					{used:GB/MB/KB/B}		Drive used Size
					{remain:GB/MB/KB/B}		Drive remain Size
					{serial}	Drive SeriaNumber
					
				default: "{name} ({id}:)";
				exampe:
					"({id}:) {name}({remain:GB}/{total:GB})"
			*/
			var rs=this.list();
			var str="<select id=\""+id+"\">";
			if(rs){
				var fold={":GB":1024*1024*1024,":MB":1024*1024,":KB":1024,":B":1};
				for(var i=0,l=rs.length;i<l;i++){
					var tmp=temptag
					.replace(/\{name\}/g,rs[i].Name)
					.replace(/\{id\}/g,rs[i].ID)
					.replace(/\{type\}/g,rs[i].Type)
					.replace(/\{serial\}/g,rs[i].Serial)
					.replace(/\{total([\:GMKB]{0,3})\}/g,function($1,$2){
						return $F(rs[i].Size.total/fold[$2],1)+$2.replace(":","");
					})
					.replace(/\{used([\:GMKB]{0,3})\}/g,function($1,$2){
						return $F(rs[i].Size.used/fold[$2],1)+$2.replace(":","");
					})
					.replace(/\{remain([\:GMKB]{0,3})\}/g,function($1,$2){
						return $F(rs[i].Size.remain/fold[$2],1)+$2.replace(":","");
					});
					str+="<option value=\""+rs[i].ID+"\">"+tmp+"</option>";
				}
			}else{
				str+="<option value=\"\">ʧ</option>";
			}
			str+="</select>";
			return str;
		},
		list:function(){
			if(this.obj){
				var drivelist=[];
				var e=new Enumerator(this.obj.Drives);
				for(;!e.atEnd();e.moveNext()){
					var i=e.item();
					var tt=i.DriveType;
					var name="";
					var size={
						total:0,
						used:0,
						remain:0
					};
					switch(tt){
						case 3:
							name=i.ShareName;break;
						default:
							switch(tt){
								case 0:
									name="δ֪豸";break;
								case 1:
									name="ƶ豸";break;
								case 2:
									name="ش";break;
								case 3:
									name="";break;
								case 4:
									name="DVD/CD ROM";break;
								case 5:
									name="RAM ";break;
							}
							if(i.isReady){
								name=i.VolumeName?i.VolumeName:"ش";
								size={
									total:i.totalSize,
									used:(i.totalSize-i.availableSpace),
									remain:i.availableSpace
								};
							}else{
								name+="(δ)";
							}
					}
					drivelist.push({
						"ID":i.DriveLetter,
						"Type":tt,
						"Name":name,
						"Serial":(i.isReady?i.SerialNumber:0),
						"Size":size
					});
				}
				return drivelist;
			}else{
				return false;
			}
		}
	},
	Font:{
		obj:null,
		inited:false,
		init:function(){
			if(!this.inited){
				var tmp=Dom.Html.add("dlgHelperdiv","div",null,"width:0px;height:0px;");
				Dom.Html.value(tmp,'<OBJECT id=dlgHelper CLASSID="clsid:3050f819-98b5-11cf-bb82-00aa00bdce0b" width="0px" height="0px"></OBJECT> ');
			}
			this.inited=true;
			this.obj=$("dlgHelper").fonts;
		},
		list:function(type){
			if(!type){type="all";}
			/*type=[all,cn,en,other]*/
			this.init();
			var em=new Enumerator(this.obj);
			var rs=[];
			for(;!em.atEnd();em.moveNext()){
				var tmp=em.item()+"";
				if(type=="cn"){
					if(/[\u4E00-\u9FA5]+/.test(tmp)){
						rs.push(tmp);
					}
				}else if(type=="en"){
					if(/^[^\u4E00-\u9FA5]+$/.test(tmp)){
						rs.push(tmp);
					}
				}else{
					rs.push(tmp);
				}
			}
			return rs;
		},
		check:function(fontname){
			this.init();
			var em=new Enumerator(this.obj);
			var rs=[];
			for(;!em.atEnd();em.moveNext()){
				if(fontname == (em.item()+"")){
					return true;
				}
			}
			return false;
		},
		add:function(path,abs){
			path=abs?path:(external.path+path);
			external.addFont(path);
		},
		del:function(path,abs){
			path=abs?path:(external.path+path);
			external.delFont(path);
		},
		control:function(id,type,select){
			/*type from list*/
			if(!id){id=$R(16);}
			if(!select){select="";}
			var arr=this.list(type);
			var str="<select id='"+id+"'>";
			for(var i=0,l=arr.length;i<l;i++){
				str+="<option value='"+arr[i]+"'"+(select==arr[i]?" selected":"")+">"+arr[i]+"</option>";
			}
			str+="</select>";
			return str;
		}
	},
	Reg:{
		pre:{
			/*some registry used always*/
		},
		type:{
			STR:"REG_SZ", /*Regular String with end \0*/
			STR_EX:"REG_EXPAND_SZ", /*String with variable such as %WINDIR%*/
			BIN:"REG_BINARY", /*Binary data*/
			INT:"REG_DWORD" /*Integer with 4 byte(32 bit)*/
		},
		root:"",
		regObj:null,
		change:function(path,sep){
			if(sep){var x=new RegExp(seq,"gi");path=path.replace(x,"\\");}
			this.root=path||"";
		},
		open:function(path,sep){
			if(sep){var x=new RegExp(seq,"gi");path=path.replace(x,"\\");}
			this.root=path||"";
			try{
				this.regObj=Win.obj(Win.com.WSH);
			}catch(e){
				alert("Create Registry Object Error");
			}
		},
		read:function(path){
			if(this.regObj){
				var obj=this.regObj;
				return obj.RegRead(this.root+path);
			}else{
				alert("you should run Reg.open function to initiate this Object");
			}
		},
		write:function(path,value,type){
			if(this.regObj){
				var obj=this.regObj;
				obj.RegWrite(this.root+path,value,type);
			}else{
				alert("you should run Reg.open function to initiate this Object");
			}
		},
		del:function(path){
			if(this.regObj){
				var obj=this.regObj;
				return obj.RegDelete(this.root+path);
			}else{
				alert("you should run Reg.open function to initiate this Object");
			}
		},
		close:function(){
			this.regObj=null;
		}
	}
};
/*Socket Operation*/
var Socket={
	/*
	p1: onConnect,
	p2: onRead,
	p3: onError,
	p4: onClose,
	p5: onConnecting,
	p6: onWrite
	*/
	open:function(host,ip,p1,p2,p3,p4,p5,p6){
		return external.socketOpen(host,ip,p1||"",p2||"",p3||"",p4||"",p5||"",p6||"");
	},
	send:function(sid,data){
		if(data){
			data="0x"+data.replace(/\s+/g," 0x");
			external.socketSend(sid,data);
		}
	},
	close:function(sid){
		external.socketClose(sid);
	},
	encode:function(str){
		var str=str.split("");
		for(var i=0;i<str.length;i++){
			str[i]=str[i].charCodeAt(0).toString(16).toUpperCase();
		}
		return str.join(" ");
	},
	decode:function(str,header,end){
		header=header||0;
		end=end||0;
		var chars="%"+str.replace(/^\s+|\s+$/g,"").replace(/\s+/g,"%");
		chars=chars.substring(header*3,chars.length-end*3)
		return decodeURIComponent(chars);
	}
};
/*Net Operation*/
var Net={
	version:["Msxml2.XMLHTTP.5.0","Msxml2.XMLHTTP.4.0","Msxml2.XMLHTTP"],
	serverVersion:["Msxml2.serverXMLHTTP.5.0","Msxml2.serverXMLHTTP.4.0"],
	curversion:-1,
	netarray:{},
	create:function(){
		var myhttp=null;
		var objversion=this.version;
		if(this.cookie){objversion=this.serverVersion;}
		if(this.curversion>-1){
			myhttp=Win.obj(objversion[this.curversion]);
		}else{
			for(var i=0;i<objversion.length;i++){
				try{
					 myhttp=Win.obj(objversion[i]);
					 this.curversion=i;
					 break;
				}catch(e){}
			}
		}
		var hash=$R(16);
		this.netarray[hash]=myhttp;
		return hash;
	},
	header:function(NETHANDLE,key,value){
		var hash=NETHANDLE;
		var h=this.netarray[hash];
		if(h){
			if(value||value===""||value===0){
				h.setRequestHeader(key,value);
			}else{
				return getResponseHeader(key);
			}
		}
	},
	open:function(NETHANDLE,url,async,method){
		var hash=NETHANDLE;
		var h=this.netarray[hash];
		if(async!==false){async=true;}
		if(method!="POST"){method="GET";}
		if(h){
			h.open(method,url,async);
		}
	},
	send:function(NETHANDLE,text){
		var hash=NETHANDLE;
		var h=this.netarray[hash];
		if(h){
			h.send(text||null);
		}
	},
	data:function(dobj){
		var rs=[];
		var codetype=dobj["$codetype$"]||"";
		delete dobj["$codetype$"];
		for(var i in dobj){
			switch(codetype){
				case "escape":
					rs.push(i+"="+escape(dobj[i]));break;
				case "encode":
					rs.push(i+"="+encodeURI(dobj[i]));break;
				default:
					rs.push(i+"="+dobj[i]);break;
			}
		}
		return rs.join("&");
	},
	change:function(NETHANDLE,callback,type,async,failfunc){
		var hash=NETHANDLE;
		var h=this.netarray[hash];
		if(async!==false){async=true;}
		if(!type){type="text";}
		if(h){
			if(async){
				var that=this;
				h.onreadystatechange=function(){
					if(h.readyState==4){
						if(h.status==200){
							if(Net.cookie){
								Net.addCookie(h.getAllResponseHeaders());
							}
							if(callback){
								var rsdata=[];
								var types=type.split(",");
								for(var i=0;i<types.length;i++){
									var tmp=null;
									switch(types[i]){
										case "xml":
											tmp=h.responseXML;break;
										case "stream":
											tmp=h.responseBody;break;
										case "json":
											tmp=(h.responseText?eval("("+h.responseText+")"):{});break;
										case "json_array":
											tmp=(h.responseText?eval("("+h.responseText+")"):[]);break;
										case "header":
										case "headers":
											tmp=h.getAllResponseHeaders();break;
										default:
											if(type.substring(0,7)=="header:"&&type.length>7){
												type=type.replace(/^header\:/,"");
												tmp=h.getResponseHeader(type);
											}else if(type.substring(0,8)=="charset:"&&type.length>8){
												type=type.replace(/^charset\:/,"");
												tmp=Stream.text(h.responseBody,type);
											}else{
												tmp=h.responseText;
											}
											break;
									}
									rsdata.push(tmp);
								}
								that.close(NETHANDLE);
								if(types.length>1){
									callback(rsdata);
								}else{
									callback(rsdata[0]);
								}
							}
						}else{
							if(failfunc){failfunc(h.status)}
						}
					}
				};
			}
		}
	},
	help:function(func){
		alert(this[func]);
	},
	post:function(url,data,callback,type,refer,async,headers,failfunc){
		/*Trahf*/
		var NETHANDLE=this.create();
		this.request(NETHANDLE,url,data,callback,type,refer,async,"POST",headers,failfunc);
	},
	get:function(url,callback,type,refer,async,headers,failfunc){
		var NETHANDLE=this.create();
		this.request(NETHANDLE,url,{},callback,type,refer,async,"GET",headers,failfunc);
	},
	addCookie:function(headers){
		var sc=this.getSetCookies(headers);
		if(sc){
			Net.cookie+=";"+sc;
			//alert(Net.cookie);
		}
	},
	request:function(NETHANDLE,url,data,callback,type,refer,async,method,headers,failfunc){
		var hash=NETHANDLE;
		var h=this.netarray[hash];
		if(async!==false){async=true;}
		if(!type){type="text";}
		if(method!="POST"){method="GET";}
		if(!headers){headers={};}
		if(h){
			if(async){
				this.change(NETHANDLE,callback,type,async,failfunc);
			}
			this.open(NETHANDLE,url,async,method);
			if(method=="POST"){
				headers["CONTENT-TYPE"]="application/x-www-form-urlencoded";
			}
			if(refer){
				headers["Referer"]=refer;
			}
			if(this.cookie){
				headers["Cookie"]=this.cookie;
			}
			for(var i in headers){
				this.header(NETHANDLE,i,headers[i]);
			}
			this.send(NETHANDLE,this.data(data));
			if(!async){
				if(h.status==200){
					if(Net.cookie){
						Net.addCookie(h.getAllResponseHeaders());
					}
					if(callback){
						var rsdata=[];
						var types=type.split(",");
						for(var i=0;i<types.length;i++){
							var tmp=null;
							switch(types[i]){
								case "xml":
									tmp=h.responseXML;break;
								case "stream":
									tmp=h.responseBody;break;
								case "json":
									tmp=(h.responseText?eval("("+h.responseText+")"):{});break;
								case "json_array":
									tmp=(h.responseText?eval("("+h.responseText+")"):[]);break;
								case "header":
								case "headers":
									tmp=h.getAllResponseHeaders();break;
								default:
									if(type.substring(0,7)=="header:"&&type.length>7){
										type=type.replace(/^header\:/,"");
										tmp=h.getResponseHeader(type);
									}else if(type.substring(0,8)=="charset:"&&type.length>8){
										type=type.replace(/^charset\:/,"");
										tmp=Stream.text(h.responseBody,type);
									}else{
										tmp=h.responseText;
									}
									break;
							}
							rsdata.push(tmp);
						}
						that.close(NETHANDLE);
						if(types.length>1){
							callback(rsdata);
						}else{
							callback(rsdata[0]);
						}
					}
				}else{
					if(failfunc){failfunc(h.status)}
				}
			}
		}
	},
	headers:function(data){
		var lines=data.split("\r\n");
		var sets={};
		for(var i=0;i<lines.length;i++){
			var tmp=lines[i];
				tmp=$T(tmp);
			if(tmp){
				tmp=tmp.split(":");
				var key=tmp[0].toLowerCase();
				if(!sets[key]){
					sets[key]=[];
				}
				sets[key].push(tmp[1]);
			}
		}
		return sets;
	},
	cookie:"",
	getSetCookies:function(data){
		var dekey={"PATH":1,"EXPIRES":1,"DOMAIN":1}
		var setc=this.headers(data);
		if(setc["set-cookie"]){
			setc=setc["set-cookie"].join(";");
			var cookies=setc.split(";");
			var cookies2=[];
			for(var i=0;i<cookies.length;i++){
				var tmp=$T(cookies[i]);
				if(tmp){
					var tmp2=tmp.split("=");
					if(!dekey[tmp2[0].toUpperCase()]){
						cookies2.push(tmp);
					}
				}
			}
			cookies2=cookies2.join(";");
			return cookies2;
		}else{
			return "";
		}
	},
	close:function(NETHANDLE){
		var hash=NETHANDLE;
		if(this.netarray[hash]){
			try{
				this.netarray[hash].close();
			}catch(e){}
			this.netarray[hash]=null;
			delete this.netarray[hash];
		}
	},
	Amf:{
		id:"",
		pageReady:false,
		swfReady:false,
		obj:null,
		callback:null,
		item:0,
		create:function(id,url,callback){
			/*add a window onload event*/
			Dom.Event.add(window,"load",function(){
				Net.Amf.pageReady=true;
			});
			this.id=id;
			this.callback=callback;
			var str='<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"';
				str+=' id="'+id+'" width="0" height="0"';
				str+=' codebase="http://fpdownload.macromedia.com/get/flashplayer/current/swflash.cab" style="position:absolute;">';
				str+=' <param name="movie" value="'+(url||external.path+'lib\\use\\Jsamf.swf')+'" />';
				str+=' <param name="quality" value="high" />';
				str+=' <param name="bgcolor" value="#869ca7" />';
				str+=' <param name="allowScriptAccess" value="always" />';
				str+=' <param name="allowNetWorking" value="all" />';
				str+=' <embed src="'+(url||external.path+'lib\\use\\Jsamf.swf')+'" quality="high" bgcolor="#869ca7"';
				str+=' width="0" height="0" name="'+id+'" align="middle"';
				str+=' play="true"';
				str+=' loop="false"';
				str+=' quality="high"';
				str+=' allowScriptAccess="always"';
				str+=' type="application/x-shockwave-flash"';
				str+=' pluginspage="http://www.adobe.com/go/getflashplayer">';
				str+='</embed>';
				str+='</object>';
			document.write(str);
		},
		init:function(){
			this.swfReady=true;
			this.obj=document.getElementById(this.id)||window[this.id];
			if(this.callback){this.callback();}
		},
		isReady:function(){
			return this.pageReady;
		},
		indent:function(i){
			var str="";
			for(var j=0;j<i;j++){
				str+="&nbsp;&nbsp;&nbsp;&nbsp;"
			}
			return str;
		},
		show:function(obj,level){
			if(!level){level=1};
			var str="";
			for(var i in obj){
				this.item++;
				var tp=(typeof obj[i]).toLowerCase();
				if(tp == "object"&&obj[i]){
					str+=this.indent(level)+"<span style='cursor:pointer;display:;' onclick='$(\"item_list_"+this.item+"\").style.display=$(\"item_list_"+this.item+"\").style.display?\"\":\"none\";this.innerHTML=$(\"item_list_"+this.item+"\").style.display?\"+\":\"-\"'>-</span> <B>["+i+"]</B> - <font color='red'><B>"+tp+"</B></font><br/>";
					str+="<div id='item_list_"+this.item+"'>"+this.show(obj[i],level+1)+"</div>";
				}else{
					str+=this.indent(level)+". <B>["+i+"]</B> - <font color='red'><B>"+tp+"</B></font> - "+obj[i]+"<br/>";
				}
			}
			return str;
		}
	}
};
/*Database Operation*/
var Dbm={
	dbarray:{},
	dsnstr:{
		"access":"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={DBPATH};User Id={USERNAME};Password={PASSWORD};",
		"mysql":"Driver={mySQL};Server={HOST};Port={PORT};Stmt=; Database={DATABASE};Uid={USERNAME};Pwd={PASSWORD};"
	},
	dsn:function(type,param){
		var tmp=this.dsnstr[(type||"access")];
			tmp=tmp.replace(/\{DBPATH\}/gi,param["db"]||"")
				.replace(/\{DATABASE\}/gi,param["db"]||"")
				.replace(/\{USERNAME\}/gi,param["username"]||"")
				.replace(/\{PASSWORD\}/gi,param["password"]||"")
				.replace(/\{HOST\}/gi,param["host"]||"localhost")
				.replace(/\{PORT\}/gi,param["port"]||"3306");
			return tmp;
	},
	open:function(type,param){
		try{
			var DBHANDLE=$R(16);
			var conn=Win.obj(Win.com.CON);
			conn.open(this.dsn(type,param));
			this.dbarray[DBHANDLE]=conn;
			return DBHANDLE;
		}catch(e){
			alert("޷ҵ"+param["db"]+e.description);
			return null;
		}
	},
	rs:function(DBHANDLE,sql,canwrite){
		var rs=Win.obj(Win.com.RDS);
		if((typeof canwrite).toLowerCase() == "object"){
			rs.open(sql,this.dbarray[DBHANDLE],canwrite["cursor"]||1,canwrite["lock"]||1);
		}else{
			if(canwrite!==false){
				rs.open(sql,this.dbarray[DBHANDLE],1,3);
			}else{
				rs.open(sql,this.dbarray[DBHANDLE],1,1);
			}
		}
		return rs;
	},
	data:function(DBHANDLE,sql,canwrite){
		return this.rs(DBHANDLE,sql,canwrite);
	},
	exec:function(DBHANDLE,sql){
		try{
			this.dbarray[DBHANDLE].execute(sql);
			return true;
		}catch(e){
			alert(e.description);
			return false;
		}
	},
	insert:function(DBHANDLE,param,dbname){
		this.update(DBHANDLE,"insert",param,dbname,true);
	},
	update:function(DBHANDLE,p1,param,dbname,newitem){
		try{
			var oo=(typeof p1).toLowerCase();
			if(oo == "object"){
				while(!p1.eof){
					for(var i in param){
						p1(i)=param[i];
					}
					p1.update();
					p1.moveNext();
				}
			}else if(oo == "string"){
				if(!DBHANDLE){alert("this update action need to specify DB Connection HANDLE");return false;}
				var sql=p1;
				if(sql){
					if(!dbname){alert("this update action need to specify database name");return false;}
					var tag=sql;
					sql="select * from "+dbname+" where "+tag;
					if(newitem&&tag=="insert"){
						sql="select * from "+dbname;
					}
				}	
				var rs=this.rs(DBHANDLE,sql,true);
				if(newitem){
					rs.addNew();
					for(var i in param){
						rs(i)=param[i];
					}
					rs.update();
					rs.moveNext();
				}else{
					while(!rs.eof){
						for(var i in param){
							rs(i)=param[i];
						}
						rs.update();
						rs.moveNext();
					}
				}
				this.clear(rs);
			}
			return true;
		}catch(e){
			alert(e.description);
			return false;
		}
	},
	del:function(DBHANDLE,p2,p3){
		var sql=p2;
		if(p3){
			sql="delete from "+p2+" where "+p3;
		}
		return this.exec(DBHANDLE,sql);
	},
	value:function(DBHANDLE,dbname,field,sql,max){
		sql=sql.replace(/^\?/,"");
		if(field){
			sql="select * from "+dbname+" where "+sql;
		}
		if(max){
			sql="select top "+max+" * from "+dbname+" where "+sql
		}
		var rs=this.rs(DBHANDLE,sql);
		var dt={};
		var ff=field.split(",");
		while(!rs.eof){
			for(var i=0;i<ff.length;i++){
				if(!dt[ff[i]]){dt[ff[i]]=[];}
				dt[ff[i]].push(""+rs(ff[i]));
			}
			rs.moveNext();
		}
		this.clear(rs);
		return dt;
	},
	list:function(DBHANDLE,dbname,field,sql,max){
		sql=sql.replace(/^\?/,"");
		if(field){
			sql="select * from "+dbname+" where "+sql;
		}
		if(max){
			sql="select top "+max+" * from "+dbname+" where "+sql
		}
		var rs=this.rs(DBHANDLE,sql);
		var dt=[];
		var ff=field.split(",");
		while(!rs.eof){
			var tmp={};
			for(var i=0;i<ff.length;i++){
				tmp[ff[i]]=""+rs(ff[i]);
			}
			dt.push(tmp);
			rs.moveNext();
		}
		this.clear(rs);
		return dt;
	},
	pages:function(total,onepage){
		return Math.ceil(total/onepage);
	},
	count:function(rs){
		return rs.recordCount;
	},
	pager:function(rs,template,cpage,onepage){
		var tmp={
			"begin":"<div><span><a href='?page={$LASTPAGE$}'>last page {$LASTPAGE$}</a></span>",
			"page":"<span style='width:30px;'><a href='?page={$NUMBER$}'>{$NUMBER$}</a></span>",
			"current":"<span style='width:30px;'><a href='?page={$NUMBER$}'><font color='red'>{$NUMBER$}</font></a></span>",
			"end":" <span><a href='?page={$NEXTPAGE$}'>next page {$NEXTPAGE$}</a></span> <span>{$PAGE$}/{$MAXPAGE$}</span></div>"
			};
			/*
			template:
				header{|}normal page{|}currentpage{|}end
				{$NUMBER$} page number
				{$PAGE$} current page
				{$MAXPAGE$} max page
				{$NEXTPAGE$} next page
				{$LASTPAGE$} last page
			*/
		cpage=parseInt(cpage||1);
		onepage=parseInt(onepage||10);
		var midp=Math.floor(onepage/2);
		var startpage=parseInt(cpage||1)-midp;
		var endpage=startpage+onepage-1;
		var maxpage=this.pages(this.count(rs),onepage);
		if(startpage>=maxpage){
			cpage=maxpage;
			endpage=maxpage;
			startpage=endpage-onepage+1;
			if(startpage<1){startpage=1}
		}
		if(startpage<=1){
			startpage=1;
			endpage=startpage+onepage-1;
			if(endpage>maxpage){endpage=maxpage};
		}
		if(endpage>=maxpage){
			endpage=maxpage;
			startpage=endpage-onepage+1;
			if(startpage<1){startpage=1}
		}
		var nextpage=((cpage+1)>maxpage)?maxpage:(cpage+1);
		var lastpage=(cpage-1)<1?1:(cpage-1);
		function rep(str){
			return str.replace(/\{\$PAGE\$\}/g,cpage)
				.replace(/\{\$MAXPAGE\$\}/g,maxpage)
				.replace(/\{\$NEXTPAGE\$\}/g,nextpage)
				.replace(/\{\$LASTPAGE\$\}/g,lastpage);
		}
		var str=rep(tmp[0]);
		for(var i=startpage;i<=endpage;i++){
			str+=((cpage==i)?tmp[2]:tmp[1]).replace(/\{\$NUMBER\$\}/g,i);
		}
		str+=rep(tmp[3]);
		return str;
	},
	table:function(rs,template,cpage,onepage){
		var infield={"PAGE":1,"COUNT":1,"INDEX":1};
		function rep(str,param){
			var s=str;
			for(var j in param){
				var p="\\[%="+j+"%\\]";
				var tt=new RegExp(p,"gi");
				s=s.replace(tt,param[j]);
			}
			return s;
		}
		var tmp={
			"begin":(template["begin"]||"<div>"),
			"odd":(template["odd"]||"<div>Page[%=PAGE%] - Record [%=COUNT%]</div>"),
			"end":(template["end"]||"</div>"),
			"fields":(template["fields"]||[])
		};
		tmp["even"]=(template["even"]||tmp["odd"]);
		var header=tmp["begin"];
		var item=tmp["odd"];
		var item2=tmp["even"];
		var end=tmp["end"];
		var fields=tmp.fields;
		if(cpage){
			var maxpage=0;
			cpage=parseInt(cpage);
			rs.absolutePage=(cpage>0?cpage:1);
			rs.pageSize=onepage||10;
			maxpage=rs.PageCount;
			if(cpage==maxpage){
				onepage=rs.recordCount-(maxpage-1)*onepage;
			}
			var str=header;
			for(var i=0;i<onepage;i++){
				var rt={};
				for(var j=0,l=fields.length;j<l;j++){
					if(!infield[fields[j]]){
						rt[fields[j]]=rs(fields[j]);
					}
				}
				rt["PAGE"]=cpage;
				rt["INDEX"]=i;
				rt["COUNT"]=((cpage-1)*onepage+i+1);
				if(i%2!=0){
					str+=rep(item,rt);
				}else{
					str+=rep(item2,rt);
				}
				if(template["callback"]){
					template.callback(rt);
				}
				rs.moveNext();
			}
			str+=end;
			return str;
		}else{
			var str=header;
			var $count=1;
			while(!rs.eof){
				var rt={};
				for(var j=0,l=fields.length;j<l;j++){
					if(!infield[fields[j]]){
						rt[fields[j]]=rs(fields[j]);
					}
				}
				rt["PAGE"]=1;
				rt["INDEX"]=$count;
				rt["COUNT"]=$count++;
				if(($count-1)%2!=0){
					str+=rep(item,rt);
				}else{
					str+=rep(item2,rt);
				}
				if(template["callback"]){
					template.callback(rt);
				}
				rs.moveNext();
			}
			str+=end;
			return str;
		}
	},
	clear:function(rs){
		rs.close();
		rs=null;
	},
	close:function(DBHANDLE){
		this.dbarray[DBHANDLE].Close();
		this.dbarray[DBHANDLE]=null;
		delete this.dbarray[DBHANDLE];
	},
	createdb:function(path,abs){
		try{
			var file=abs?(external.path+path):path;
			File.copy(external.path+"lib\\use\\nulldb",file);
			return file;
		}catch(e){
			return false;
		}
	},
	addtable:function(DBHANDLE,obj){
		try{
			this.dbarray[DBHANDLE].execute("create table "+obj);
			return true;
		}catch(e){
			return false;
		}
	},
	deltable:function(DBHANDLE,obj){
		try{
			this.dbarray[DBHANDLE].execute("drop table "+obj);
		}catch(e){
			return false;
		}
	}
};

/*Dom Operation*/
var Dom={
	$:function(id){
		if($(id)){return $(id);}
		else if(document.getElementsByName(id).length>0){
			return document.getElementsByName(id);
		}
	},
	Event:{
		eventarray:{},
		add:function(a,b,c){
			var eve=b.toLowerCase().substring(0,2)=="on"?b:("on"+b);
			var obj=$$(a);
			obj.attachEvent(eve,c);
			var EVENT_HANDLE=$R(16);
			this.eventarray[EVENT_HANDLE]={
				"e":eve,
				"o":obj,
				"f":c
			}
			return EVENT_HANDLE;
		},
		del:function(EVENT_HANDLE){
			var tmp=this.eventarray[EVENT_HANDLE];
			if(tmp&&tmp.o){
				tmp.o.detachEvent(tmp.e,tmp.f);
			}
			delete this.eventarray[EVENT_HANDLE];
		},
		obj:function(){
			return event.target||event.srcElement;
		},
		point:function(){
			return {
				x:$P(event.x)+$P(document.body.scrollLeft),
				y:$P(event.y)+$P(document.body.scrollTop)
			};
		},
		key:function(){
			return event.keyCode;
		},
		mouse:function(){
			var rs=["r","l","r","c"];
			return rs[event.button];
		}
	},
	Html:{
		/*add and delete element*/
		add:function(id,type,par,style){
			var obj=document.createElement(type);
			obj.id=id;
			obj.style.cssText=style;
			if(!document.body) document.write("<body>");
			var pobj=$$(par)||document.body;
			pobj.appendChild(obj);
			return obj;
		},
		insert:function(id,type,par,node,style){
			var obj=document.createElement(type);
			obj.id=id;
			obj.style.cssText=style;
			if(!document.body) document.write("<body>");
			var pobj=$$(par)||document.body;
			pobj.insertBefore(obj,node);
			return obj;
		},
		del:function(obj){
			var tobj=$$(obj);tobj.parentNode.removeChild(tobj);
		},
		/*show and hidden element*/
		show:function(obj){
			var tobj=$$(obj);tobj.style.display="";
		},
		hidden:function(obj){
			var tobj=$$(obj);tobj.style.display="none";
		},
		hid:function(obj){
			this.hidden(obj);
		},
		toggle:function(obj){
			var tobj=$$(obj);tobj.style.display=(tobj.style.display?"":"none");
		},
		gradient:function(obj,param){
			var tobj=$$(obj);
			if(!param){param={};}
			var from=param["from"]===0?0:(param["from"]||this.alpha(obj)||100);
			var step=param["step"]||10;
			var to=param["to"]===0?0:(param["to"]||0);
			var interval=param["interval"]===0?0:(param["interval"]||100);
			var sign=from>to?-1:1;
			this.alpha(obj,from);
			var that=this;
			Dom.Timer.start(function(){
				var alpha=that.alpha(obj);
				that.alpha(obj,alpha+sign*step);
			},interval,function(){
				var alpha=that.alpha(obj);
				return sign<0?(alpha<=to):(alpha>=to);
			});
		},
		/*css control*/
		css:function(obj,param){
			var tobj=$$(obj);
			switch((typeof param).toLowerCase()){
				case "string":
					tobj.style.cssText=param;break;
				case "object":
					for(var i in param){
						try{tobj.style[i]=param[i];}catch(e){}
					}
					break;
			}
		},
		/*size and position and index control*/
		abs:function(obj,x,y){
			var tobj=$$(obj);
			tobj.style.position="absolute";
			tobj.style.left=$P(x)+"px";
			tobj.style.top=$P(y)+"px";
		},
		move:function(obj,xdis,ydis){
			var tobj=$$(obj);
			tobj.style.left=$P(tobj.style.left)+$P(xdis)+"px";
			tobj.style.top=$P(tobj.style.top)+$P(ydis)+"px";
		},
		size:function(obj,w,h){
			var tobj=$$(obj);
			if(w.toString().indexOf("%")!=-1){
				tobj.style.width=w;
			}else{
				tobj.style.width=$P(w)+"px";
			}
			if(h.toString().indexOf("%")!=-1){
				tobj.style.height=h;
			}else{
				tobj.style.height=$P(h)+"px";
			}
		},
		front:function(obj,elems,zbase){
			var tobj=$$(obj);
			var zbase=zbase||1;
			var onum=elems.length;
			for(var i=0;i<onum;i++){
				(function(i){
					if(tobj!=elems[i]){
						Dom.Html.z($$(elems[i]),zbase++);
					}
				})(i);
			}
			this.z(tobj,zbase);
		},
		z:function(obj,z){
			var tobj=$$(obj);
			if(z||z===0){	
				tobj.style.zIndex=z;
			}else{
				return (tobj.style.zIndex||0);
			}
		},
		up:function(obj,z){
			var tobj=$$(obj);
			tobj.style.zIndex+=z;
		},
		down:function(obj,z){
			var tobj=$$(obj);
			tobj.style.zIndex-=z;
		},
		alpha:function(obj,value){
			var tobj=$$(obj);
			if(value||value===0){
				if(value<0){value==0;}
				if(value>100){value=100;}
				tobj.style.filter="alpha(opacity="+value+")";
			}else{
				if(tobj.filters["alpha"]){
					return tobj.filters["alpha"].opacity;
				}else{
					return 100;
				}
			}
		},
		/*attribute and value or innerHTML control*/
		attr:function(obj,name,value){
			var tobj=$$(obj);
			if(value||value===0||value===""||value===false){
				switch(name){
					case "class":
						tobj.className=value;break;
					default:
						tobj.setAttribute(name,value);	
				}
			}else{
				switch(name){
					case "class":
						return tobj.className;
					default:
						if(tobj&&tobj.getAttribute){
							return tobj.getAttribute(name);
						}else{
							return "";
						}
				}
			}
		},
		append:function(obj,value){
			this.value(obj,(this.value(obj)||"")+value);
		},
		value:function(obj,value){
			var tobj=$$(obj);
			var tag=tobj.tagName.toLowerCase();
			switch(tag){
				case "textarea":
				case "input":
				case "button":
					if(value||value===""||value===0){
						tobj.value=value;
					}else{
						return tobj.value;
					}
					break;
				case "select":
					var sel=tobj.selectedIndex;
					if(sel!=-1){
						if(value||value===""||value===0){
							tobj.options[sel].value=value;
						}else{
							return tobj.options[sel].value;
						}
					}
					break;
				default:
					if(value||value===""||value===0){
						tobj.innerHTML=value;
					}else{
						return tobj.innerHTML;
					}
			}
		},
		isgray:false,
		bodyshow:function(){
			if($("$BOX_BODYGRAY$")){
				Dom.Html.del("$BOX_BODYGRAY$");
			}
		},
		bodygray:function(color,alpha){
			if($("$BOX_BODYGRAY$")){
				Dom.Html.del("$BOX_BODYGRAY$");
			}
			if(!color){color="#cccccc";}
			if(!alpha){alpha=60;}
			var g=Dom.Html.add("$BOX_BODYGRAY$","div",null,"position:absolute;top:0px;left:0px;background:"+color+";width:100%;height:100%;");
			Dom.Html.alpha(g,alpha);
			isgray=true;
			return g;
		},
		By:{
			id:function(id){
				return $(id);
			},
			name:function(name){
				return document.getElementsByName(name);
			},
			classname:function(c,parent){
				var x=($$(parent)||document.body).childNodes;
				var rs=[];
				for(var i=0,l=x.length;i<l;i++){
					if(x[i].className==c){
						rs.push(x[i]);
					}
				}
				return rs;
			},
			tag:function(tag,parent){
				return ($$(parent)||document.body).getElementsByTagName(tag);
			},
			value:function(v,parent){
				var x=($$(parent)||document.body).childNodes;
				var rs=[];
				for(var i=0,l=x.length;i<l;i++){
					if(Dom.Html.value(x[i])==v){
						rs.push(x[i]);
					}
				}
				return rs;
			},
			attribute:function(name,value,parent){
				var x=($$(parent)||document.body).childNodes;
				var rs=[];
				for(var i=0,l=x.length;i<l;i++){
					if(Dom.Html.attr(x[i],name)==value){
						rs.push(x[i]);
					}
				}
				return rs;
			}
		},
		Shadow:{
			add:function(obj,param){
				var tobj=$$(obj);
				if(!param){param={};}
				var bmargin=param["margin"]||3;
				var color=param["color"]||"#ccc";
				var z=param["zindex"]||1;
				if(tobj.style.position=="absolute"){
					if(!tobj.id){tobj.id=$R(16);}
					if(!tobj.style.zIndex){tobj.style.zIndex=z+1;}
					var sd=Dom.Html.add(tobj.id+"_shadow","div",null,"z-index:"+z+";background:"+color+";");
					Dom.Html.size(sd,tobj.style.width,tobj.style.height);
					Dom.Html.abs(sd,$P(tobj.style.left)+$P(bmargin),$P(tobj.style.top)+$P(bmargin));
					return sd;
				}
			},
			id:function(obj){
				var tobj=$$(obj);
				return $(tobj.id+"_shadow");
			},
			obj:function(obj){
				var tobj=$$(obj);
				if(this.have(obj)){
					return $(tobj.id+"_shadow");
				}
			},
			have:function(obj){
				var tobj=$$(obj);
				return tobj.id&&$(tobj.id+"_shadow");
			},
			del:function(obj){
				var tobj=$$(obj);
				if(this.have(obj)){
					Dom.Html.del(tobj.id+"_shadow");
				}
			}
		},
		/*round corner*/
		corner:function(id,radius,config){
			
		},
		/*moveable*/
		moveable:function(obj,dragitem,followitem,eventFunc,cursor){
			if(!eventFunc){eventFunc={};}
			var tobj=$$(obj);
			var mvitem=dragitem?$$(dragitem):"";
			if(!followitem){followitem=[];}
			if(this.Shadow.have(obj)){followitem.push(this.Shadow.obj(obj));}
			if(this.attr(tobj,"moveable")!="yes"){
				tobj.style.position="absolute";
				if(cursor){(mvitem||tobj).style.cursor="move";}
				this.attr(tobj,"mv","no");
				this.attr(tobj,"ox","-1");
				this.attr(tobj,"oy","-1");
				var md=Dom.Event.add(mvitem||tobj,"onmousedown",function(){
					var p=Dom.Event.point();
					Dom.Html.attr(tobj,"ox",p.x);
					Dom.Html.attr(tobj,"oy",p.y);
					Dom.Html.attr(tobj,"mv","yes");
					document.body.onselectstart=function(){document.selection.empty();return false;};
					var func=eventFunc["mousedown"]||eventFunc["onmousedown"];
					if(func){func(mvitem||tobj);}
				});
				var mm=Dom.Event.add(document,"onmousemove",function(){
					if(Dom.Html.attr(tobj,"mv")=="yes"){
						var p=Dom.Event.point();
						var o={
							"x":$P(Dom.Html.attr(tobj,"ox")),
							"y":$P(Dom.Html.attr(tobj,"oy"))
						};
						Dom.Html.move(tobj,$P(p.x)-o.x,$P(p.y)-o.y);
						if(followitem.length>0){
							for(var i=0,l=followitem.length;i<l;i++){
								//Dom.Html.move($$(followitem[i]),$P(p.x)-o.x,$P(p.y)-o.y);
								Dom.Html.move($$(followitem[i]),$P(p.x)-o.x,$P(p.y)-o.y);
							}
						}
						Dom.Html.attr(tobj,"ox",p.x);
						Dom.Html.attr(tobj,"oy",p.y);
						var func=eventFunc["mousemove"]||eventFunc["onmousemove"];
						if(func){func(mvitem||tobj,$P(p.x)-o.x,$P(p.y)-o.y);}
					}
					if(Dom.Event.obj().tagName.toLowerCase()=="img"){
						event.returnValue=false;
					}
				});
				var mu=Dom.Event.add(mvitem||tobj,"onmouseup",function(){
					Dom.Html.attr(tobj,"mv","no");
					document.body.onselectstart=function(){};
					var func=eventFunc["mouseup"]||eventFunc["onmouseup"];
					if(func){func(mvitem||tobj);}
				});
				this.attr(tobj,"moveable","yes");
				this.attr(tobj,"downfunc",md);
				this.attr(tobj,"movefunc",mm);
				this.attr(tobj,"upfunc",mu);
			}
		},
		unmoveable:function(obj){
			var tobj=$$(obj);
			if(this.attr(tobj,"moveable")=="yes"){
				Dom.Event.del(this.attr(tobj,"downfunc"));
				Dom.Event.del(this.attr(tobj,"movefunc"));
				Dom.Event.del(this.attr(tobj,"upfunc"));
				this.attr(tobj,"moveable","no");
				var ehash=Dom.Html.attr(tobj,"ehash");
				if(ehash){
					Dom.Event.del(ehash);
				}
			}
		},
		/*Simple Function*/
		div:function(id,w,h,x,y,p,bg,noabs){
			return this.add(id||$R(16),"div",p,"width:"+$P(w||100)+"px;height:"+$P(h||100)+"px;left:"+$P(x||0)+"px;top:"+$P(y||0)+";background:"+(bg||"url('')")+";"+(!noabs?"position:absolute;":""));
		},
		/*form fields*/
		input:function(id,type,p,style,value,name){
			return this.add(id||$R(16),"<input type='"+type+"' name='"+(name||id)+"' value='"+(value||"")+"'/>",p,style);
		},
		/*button*/
		ButtonGroup:{
			group:{},
			add:function(id,param){
				this.group[id]=({
					"id":id,
					"current":null,
					"mouseover":param["over"]||"buttonOver",
					"mouseout":param["normal"]||"buttonNormal",
					"select":param["select"]||"buttonSelect"
				});
				return id;
			},
			del:function(id){
				delete this.group[id];
			},
			set:function(id,key,value){
				if(this.group[id]){
					this.group[id][key]=value;
				}
			},
			get:function(id){
				return this.group[id];
			}
		},
		button:function(id,param){
			var g=this.add(id||$R(16),"div",param["parent"]||"");
			if(param["group"]){
				var group=Dom.Html.ButtonGroup.get(param["group"]);
				Dom.Html.attr(g,"class",group["mouseout"]);
			}
			if(param["background"]){g.style.background=param["background"];}
			if(param["border"]){g.style.border=param["border"];}
			Dom.Event.add(g,"click",function(){
				if(param["group"]){
					var group=Dom.Html.ButtonGroup.get(param["group"]);
					if(group["current"]){
						Dom.Html.attr(group["current"],"class",group["mouseout"]);
					}
					Dom.Html.attr(g,"class",group["select"]);
					Dom.Html.ButtonGroup.set(param["group"],"current",g);
				}
				if(param["click"]){var x=param["click"];x(g)};
			});
			Dom.Event.add(g,"mouseout",function(){
				if(param["group"]){
					var group=Dom.Html.ButtonGroup.get(param["group"]);
					if(group["current"]!=g){
						Dom.Html.attr(g,"class",group["mouseout"]);
					}
				}
				if(param["out"]){var x=param["out"];x(g)};	
			});
			Dom.Event.add(g,"mouseover",function(){
				if(param["group"]){
					var group=Dom.Html.ButtonGroup.get(param["group"]);
					if(group["current"]!=g){
						Dom.Html.attr(g,"class",group["mouseover"]);
					}
				}
				if(param["over"]){var x=param["over"];x(g)};	
			});
			Dom.Html.value(g,param["text"]||"ť");
			return g;
		},
		tabpage:function(id,param,func){
			if(!param){param={};}
			if(!id){id=$R(16);}
			var bordercolor=param["bordercolor"]||"#000";
			var p=this.add(id,"div",param["parent"],"width:250px;height:250px;"+param["tab_style"]);
			Dom.Html.attr(p,"x_color1","#f1f1f1");
			Dom.Html.attr(p,"x_color2","#ccff00");
			Dom.Html.attr(p,"x_bordercolor","#000");
			Dom.Html.attr(p,"x_index","0");
			Dom.Html.attr(p,"x_headerheight","20px");
			Dom.Html.attr(p,"x_headerwidth","50px");
			Dom.Html.attr(p,"x_bodyheight","230px");
			Dom.Html.attr(p,"innerObject",id+"_body");
			Dom.Html.attr(p,"innerObjectAttr","x_bodyheight");
			var h=this.add(id+"_header","div",p,"clear:both;width:100%;height:20px;"+(param["head_style"]||""));
			var b=this.add(id+"_body","div",p,"clear:both;width:100%;height:230px;border:1px solid "+bordercolor+";"+(param["body_style"]||""));
			return {
				"index":0,
				"count":0,
				"tab":p,
				"head":h,
				"body":b,
				"add":function(text,clickfunc,before){
					var color1=Dom.Html.attr(p,"x_color1")||"#f1f1f1";
					var color2=Dom.Html.attr(p,"x_color2")||"#ccff00";
					var bordercolor=Dom.Html.attr(p,"x_bordercolor")||"#000";
					var headerheight=Dom.Html.attr(p,"x_headerheight")||"20px";
					var headerwidth=Dom.Html.attr(p,"x_headerwidth")||"50px";
					var bodyheight=Dom.Html.attr(p,"x_bodyheight")||"230px";
					var index=this.count;
					var hitem=null;
					var hitem_style="float:left;text-align:center;width:"+headerwidth+";height:"+headerheight+";line-height:"+headerheight+";border:1px solid "+bordercolor+";cursor:pointer;"+(this.index==index?"background:"+color1+";":"background:"+color2+";")+(param["head_item_style"]||"");
					if(!before&&before!==0){
						hitem=Dom.Html.add(id+"_header_"+index,"div",h,hitem_style);
					}else{
						hitem=Dom.Html.insert(id+"_header_"+index,"div",h,$(id+"_header_"+before),hitem_style);
					}
					var bitem=Dom.Html.add(id+"_body_"+index,"div",b,"float:left;width:100%;height:100%;background:"+color1+";"+(this.index==index?"":"display:none;")+(param["body_item_style"]||""));
					Dom.Html.value(hitem,"<span id='"+id+"_text_"+index+"'>"+(text||"")+"</span>");
					Dom.Html.attr(hitem,"parentObject",id);
					Dom.Html.attr(bitem,"parentObject",id);
					var l=Dom.Html.add(id+"_line_"+index,"div",hitem,"position:relative;top:2px;left:0px;width:0px;overflow:hidden;border:0px solid none;height:2px;background:"+(this.index==index?color1:bordercolor)+";"+(param["line_style"]||""));
					l.style.width=($P(hitem.style.width)-2)+"px";
					Dom.Event.add(hitem,"click",function(){
						var tmpindex=Dom.Html.attr(p,"x_index")||0;
						if($(id+"_body_"+tmpindex)){	
							Dom.Html.hid(id+"_body_"+tmpindex);
							$(id+"_line_"+tmpindex).style.background=Dom.Html.attr(p,"x_bordercolor")||"#000";
							$(id+"_header_"+tmpindex).style.background=Dom.Html.attr(p,"x_color2")||"#ccff00";
						}
						Dom.Html.show(bitem);
						l.style.background=Dom.Html.attr(p,"x_color1")||"#f1f1f1";
						hitem.style.background=Dom.Html.attr(p,"x_color1")||"#f1f1f1";
						Dom.Html.attr(p,"x_index",index)
						if(clickfunc){clickfunc()};
					});
					this.count++;
					return {
						"head":hitem,
						"text":$(id+"_text_"+index),
						"body":bitem,
						"index":index
					};
				}
			};
		},
		/*panel*/
		panel:function(id,param,func){
			if(!param){param={};}
			if(!id){id=$R(16);}
			if(!param["panel_width"]){param["panel_width"]=100;}
			if(!param["panel_height"]){param["panel_height"]=100;}
			param["panel_style"]="width:"+param["panel_width"]+"px;height:"+param["panel_width"]+"px;"+(param["panel_style"]||";line-height:22px;background:#fff;border:1px solid #000;top:0px;left:0px;");
			param["head_style"]="width:100%;"+(param["head_style"]||";height:22px;line-height:22px;background:#3366cc;");
			param["body_style"]="width:100%;"+(param["body_style"]||";background:#fff;");
			var p=this.add(id,"div",param["parent"],param["panel_style"]);
			var h=this.add(id+"_header","div",p,param["head_style"]);
			param["body_style"]=param["body_style"]+";height:"+($P(p.style.height)-$P(h.style.height))+"px;";
			var b=this.add(id+"_body","div",p,param["body_style"]);
			var s="";
			var cbt="";
			var clsfunc=function(){
				Dom.Html.del(p);
				var zitems=window[param["zitem"]];
				for(var i=0;i<zitems.length;i++){
					if(p.id==zitems[i]){
						window[param["zitem"]].splice(i,1);
					}
				}
			};
			if(param["closebutton"]){
				if(!p.style.left||!p.style.top){
					Dom.Html.abs(p,0,0);
				}
				cbt=Dom.Html.add(id+"_closebutton","div",p,param["closebutton"]);
				Dom.Event.add(cbt,"click",clsfunc);
			}
			if(param["minbutton"]){
				if(!p.style.left||!p.style.top){
					Dom.Html.abs(p,0,0);
				}
				cbt=Dom.Html.add(id+"_minbutton","div",p,param["minbutton"]);
				Dom.Event.add(cbt,"click",function(){
					//Dom.Html.del(p);
				});
			}
			if(param["shadow"]){
				if(!p.style.left||!p.style.top){
					Dom.Html.abs(p,0,0);
				}
				s=Dom.Html.Shadow.add(p,param["shadow"]);
			}
			if(!func){func={};}
			if(!func["mousemove"]){
				func["mousedown"]=function(e){
					Dom.Html.front(p,window[param["zitem"]]||[]);
				}
				if(!param["noalpha"]){
					func["mousemove"]=function(e){
						Dom.Html.alpha(p,60);
					}
					func["mouseup"]=function(e){
						Dom.Html.alpha(p,100);
					}
				}
			}
			if(param["moveable"]){
				if(!p.style.left||!p.style.top){
					Dom.Html.abs(p,0,0);
				}
				Dom.Html.moveable(p,h,[],func,true);
			}
			return {
				"panel":p,
				"head":h,
				"body":b,
				"shadow":s,
				"close":clsfunc
			};
		},
		list:function(id,param){
			var tid=id||$R(8);
			var s=Dom.Html.add(tid,"ul",param["parent"],param["style"]);
			return {
				list:s,
				itemcount:0,
				items:{},
				selectedIndex:-1,
				colorconfig:null,
				add:function(itemtext,head){
					if(head){
						var tmp=Dom.Html.add(tid+"_item"+this.itemcount,"li",$(tid),param["headstyle"]||param["itemstyle"]);
					}else{
						var tmp=Dom.Html.add(tid+"_item"+this.itemcount,"li",$(tid),param["itemstyle"]);
					}
					Dom.Html.value(tmp,itemtext);
					this.items[this.itemcount]=tid+"_item"+this.itemcount;
					this.itemcount++;
				},
				adds:function(arr){
					for(var i=0;i<arr.length;i++){
						this.add(arr[i]);
					}
				},
				del:function(i){
					if($(tid+"_item"+i)){
						Dom.Html.del(tid+"_item"+i);
					}
					delete this.items[i]
				},
				dels:function(arr){
					for(var i=0;i<arr.length;i++){
						this.del(arr[i]);
					}
				},
				clear:function(){
					var items=this.items;
					for(var i in items){
						Dom.Html.del(items[i]);
						delete items[i];
					}
					this.itemcount=0;
				},
				color:function(param,datagrid,cols){
					if(!this.colorconfig){
						this.colorconfig=param;
					}else{
						param=this.colorconfig;
					}
					var that=this;
					var ct=0;
					var precol=tid.replace(/\d+$/,"");
					if(param["odd"]||param["even"]){
						if(!param["odd"]){param["odd"]=param["color"];}
						if(!param["even"]){param["even"]=param["color"];}
						if(!param["over"]){param["over"]=param["color"];}
						if(!param["select"]){param["select"]=param["color"];}
						var items=this.items;
						for(var i in items){
							(function(i){
								if(ct%2){
									$(items[i]).style.background=param["odd"];
								}else{
									$(items[i]).style.background=param["even"];
								}
								Dom.Event.add($(items[i]),"click",function(){
									if(that.selectedIndex!=-1){
										if($(that.selectedIndex)){
											
											var itemIndex=parseInt(that.selectedIndex.replace(new RegExp(tid+"_item"),""));
											if(datagrid){
												for(var m=0;m<datagrid;m++){
													if(itemIndex%2){
														$(precol+m+"_item"+itemIndex).style.background=param["odd"];
													}else{
														$(precol+m+"_item"+itemIndex).style.background=param["even"];
													}
												}
											}else{
												if(itemIndex%2){
													$(that.selectedIndex).style.background=param["odd"];
												}else{
													$(that.selectedIndex).style.background=param["even"];
												}
											}
										}
									}
									if(!datagrid){
										$(items[i]).style.background=param["select"];
										that.selectedIndex=items[i];
									}else{
										var itemIndex=parseInt(items[i].replace(new RegExp(tid+"_item"),""));
										for(var m=0;m<datagrid;m++){
											$(precol+m+"_item"+itemIndex).style.background=param["select"];
											cols[m].selectedIndex=precol+m+"_item"+itemIndex;
										}
									}
									if(param["itemclick"]){
										param["itemclick"]($(items[i]),i);
									}
								});
								Dom.Event.add($(items[i]),"mouseover",function(){
									if(that.selectedIndex!=items[i]){
										if(!datagrid){
											$(items[i]).style.background=param["over"];
										}else{
											var itemIndex=parseInt(items[i].replace(new RegExp(tid+"_item"),""));
											for(var m=0;m<datagrid;m++){
												$(precol+m+"_item"+itemIndex).style.background=param["over"];
											}
										}
									}
									if(param["itemover"]){
										param["itemover"]($(items[i]));
									}
								});
								Dom.Event.add($(items[i]),"mouseout",function(){
									if(that.selectedIndex!=items[i]){
										var itemIndex=parseInt(items[i].replace(new RegExp(tid+"_item"),""));
										if(!datagrid){
											if(itemIndex%2){
												$(items[i]).style.background=param["odd"];
											}else{
												$(items[i]).style.background=param["even"];
											}
										}else{
											for(var m=0;m<datagrid;m++){
												
												if(itemIndex%2){
													$(precol+m+"_item"+itemIndex).style.background=param["odd"];
												}else{
													$(precol+m+"_item"+itemIndex).style.background=param["even"];
												}
											}
										}
									}
									if(param["itemout"]){
										param["itemout"]($(items[i]));
									}
								});
							})(i);
							ct++;
						}
					}
					
				}
			};
		},
		datagrid:function(id,param,columns){
			var tid=id||$R(8);
			var hc=Dom.Html.add(tid+"_head","div",param["parent"],param["headstyle"]);
			var s=Dom.Html.add(tid,"div",param["parent"],param["style"]);
			var cols=[];
			for(var i=0;i<columns.length;i++){
				(function(i){
					if(!columns[i]["itemstyle"]){
						columns[i]["itemstyle"]=param["itemstyle"];
					}
					columns[i]["parent"]=tid;
					columns[i]["style"]=param["columnstyle"]+";float:left;width:"+columns[i]["width"]+";";
					var ll=Dom.Html.list(tid+"_column"+i,columns[i]);
					cols.push(ll);
					var hd=Dom.Html.list(tid+"_columnhead"+i,{
						"parent":tid+"_head",
						"style":columns[i]["style"],
						"headstyle":param["headstyle"]
					});
					hd.add(columns[i]["text"],true);
				})(i);
			}
			return {
				data:[],
				addRow:function(contents,head){
					this.data.push(contents);
					for(var i=0;i<cols.length;i++){
						if(cols[i]){
							var tmpcontent=contents[i].replace(/\[%=itemindex%\]/g,this.data.length-1);
							cols[i].add(tmpcontent,head);
						}
					}
				},
				delRow:function(index){
					for(var i=0;i<cols.length;i++){
						if(cols[i]){
							cols[i].del(index);
						}
					}
					this.data.splice(index,1);
					this.reDraw();
				},
				color:function(cparam){
					for(var i=0;i<cols.length;i++){
						cols[i].color(cparam,cols.length,cols);
					}
				},
				clear:function(){
					for(var i=0;i<cols.length;i++){
						if(cols[i]){
							cols[i].clear();
						}
					}
					this.data=[];
				},
				reDraw:function(){
					var arr=this.data.splice(0,this.data.length);
					this.clear();
					for(var i=0;i<arr.length;i++){
						this.addRow(arr[i]);
					}
					this.color();
				}
			};
		}
	},
	Timer:{
		timerarray:{},
		start:function(func,interval,condition,maxcount){
			pthis=this;
			var TIMEHANDLE=$R(16);
			this.timerarray[TIMEHANDLE]={
				"count":0,
				"maxcount":maxcount||Infinity,
				"timer":setInterval(function(){
					var $self=pthis.timerarray[TIMEHANDLE];
					if($self.count>$self.maxcount||(condition&&condition())){
						pthis.stop(TIMEHANDLE);
					}else{
						func();
						$self.count++;
					}
				},interval||1000)
			};
			return TIMEHANDLE;
		},
		stop:function(TIMEHANDLE){
			if(this.timerarray[TIMEHANDLE]){
				clearInterval(this.timerarray[TIMEHANDLE].timer);
				delete this.timerarray[TIMEHANDLE];
			}
		},
		Counter:{
			timer:null,
			start:function(id,direction,basic,endFunc){
				Dom.Html.value(id,basic||"0");
				if(!direction){
					Dom.Html.value(id,basic||"60");
					this.timer=Dom.Timer.start(function(){
						Dom.Html.value(id,$P(Dom.Html.value(id))-1);
						if($P(Dom.Html.value(id))==0){
							if(endFunc){endFunc();}
						}
					},1000);
				}else{
					this.timer=Dom.Timer.start(function(){
						Dom.Html.value(id,$P(Dom.Html.value(id))+1);
					},1000);
				}
			},
			stop:function(){
				if(this.timer){
					Dom.Timer.stop(this.timer);
					this.timer=null;
				}
			}
		}
	},
	Cookie:{
		load:function(data){
			/*load external cookies data*/
			var c=data.split(";");
			var h={};
			for(var i=0,l=c.length;i<l;i++){
				var tmp=c[i].split("=");
				h[$T(tmp[0])]=$T(tmp[1]||"");
			}
			return {
				"data":h,
				"read":function(name){
					return this.data[name]||false;
				},
				"write":function(name,value){
					this.data[name]=value||"";
				},
				"text":function(){
					var tmp=[];
					for(var i in this.data){
						tmp.push(i+"="+data[i]);
					}
					return tmp.join("; ");
				}
			};
		},
		text:function(){
			return document.cookie;
		},
		hash:function(){
			var c=document.cookie.split(";");
			var h={};
			for(var i=0,l=c.length;i<l;i++){
				var tmp=c[i].split("=");
				h[$T(tmp[0])]=$T(tmp[1]||"");
			}
			return h;
		},
		read:function(name){
			return this.hash()[name]||false;
		},
		write:function(name,value){
			document.cookie=name+"="+value+";"
		},
		temp:function(name,value){
			/*not be used outside*/
			if(value){
				this.write(name,value);
			}
			return this.read(name);
		},
		domain:function(value){
			return this.temp("domain",value);
		},
		path:function(value){
			return this.temp("path",value);
		},
		expires:function(value){
			return this.temp("expires",value);
		}
	},
	Query:{
		hash:function(key,topframe,spliter){
			var o=topframe?top.location:self.location;
			var hash=o.hash;
				hash=hash.replace(/^#/,"").split((spliter||"&"));
			var rs={};
			for(var i=0,l=hash.length;i<l;i++){
				var tmp=hash[i].split("=");
				rs[tmp[0]]=tmp[1];
			}
			if(rs[key]){return rs[key];}else{return false};
		},
		$:function(key,topframe){
			var o=top?topframe.location:self.location;
			var sh=o.search;
				sh=sh.replace(/^\?/,"").split("&");
			var rs={};
			for(var i=0,l=sh.length;i<l;i++){
				var tmp=sh[i].split("=");
				rs[tmp[0]]=tmp[1];
			}
			if(rs[key]){return rs[key];}else{return false};
		}
	},
	Random:{
		time:function(type){
			type=type||"short";
			var time=new Date().getTime();
			switch(type){
				case "short":
					return Math.floor(time/1000);
				case "s":
					return Math.floor(time/1000);
				case "long":
					return time;
				case "l":
					return time;
			}
		},
		number:function(){
			return Math.random();
		}
	}
};
/*Encode & Decode*/
var Cod={
	MD5:{
		encode:function(){
		
		}
	},
	BASE64:{
		encode:function(str){
		
		},
		decode:function(str){
		
		}
	}
};
/*Extend Object*/
var Ext={
	Toolmao:{
		Gainover:{
			/*to Extend Function of this application*/
			/*
				Ext.Toolmao.Gainover={
					//put some code here
				}
			*/
		}
	}
};
/*window onload*/
window.attachEvent("onload",function(){
	installXMLHTTP();
	for(var i=0,l=Win.Drag.item.length;i<l;i++){
		var tmp=$(Win.Drag.item[i]);
		if(tmp){
			with(tmp){
				onmousedown=Win.Drag.mouseDown;
				onmouseup=Win.Drag.mouseUp;
				onmousemove=Win.Drag.mouseMove;
			}
		}
	}
});

/*extension functions*/
String.prototype.lc=function(){
	return this.toLowerCase();
}
String.prototype.uc=function(){
	return this.toUpperCase();
}
String.prototype.getMatch=function(pat,multi){
	if(!multi){
		return (this.match(pat)||["",""])[1];
	}else{
		return this.match(pat)||[];
	}
}
function installXMLHTTP(){
	try{
		var o=new ActiveXObject("Msxml2.xmlhttp.5.0");
	}catch(e){
		alert("ĵϿȱMSXML2.XMLHTTP5.0\n\nڳ򽫳ע\n\n");
		try{
			external.regsvr(external.path+"lib\\use\\msxml5.dll");
		}catch(e){
			alert("ܿϧ,עʧ!ҳ!\nwww.toolmao.com/viewnews-546");
			window.open("http://www.toolmao.com/viewnews-546");
		}
	}
}
function RegExpCN(str,modifier){
	/*
	 :
		[$$]1-6$[$ĸ]2-5
		//alert(("[$]0-$[$ĸ]1-5"));
		//alert(("[$ǿհ]0-$[$$ĸ]1-5"));
		var x=("[$]5-10","i");
		var str="qq22871560qq34567qq12345";
		alert(x.ȡȫ(str));
	*/
	str=str.replace(/\$ַ/g,"\\s\\S").replace(/\$ַ/g,"\\s\\S").replace(/\$/g,"\\s\\S").replace(/\$ֺĸ/g,"\\W").replace(/\$ĸ/g,"\\W").replace(/\$ֺĸ/g,"\\w").replace(/\$ĸ/g,"\\w").replace(/\$ǿհ/g,"\\S").replace(/\$հ/g,"\\s").replace(/\$/g,"\\n").replace(/\$س/g,"\\r").replace(/\$/g,"\\D").replace(/\$/g,"\\d").replace(/\$ĸ/g,"^a-zA-Z").replace(/\$ĸ/g,"a-zA-Z").replace(/(\d+)-(\d+|)(?)/gi,function($1,$2,$3){
		if($2=="0"){
			if($3=="1"){
				return "?";
			}else if($3==""){
				return "*";
			}else{
				return "{0,"+$3+"}";
			}
		}else if($2=="1"){
			if($3==""){
				return "+";
			}else{
				return "{1,"+$3+"}";
			}
		}else{
			return "{"+$2+","+$3+"}";
		}
	}).replace(/\$/,"?").replace(/\$/,"^");
	return {
		"setGlobal":false,
		"expression":new RegExp(str,modifier),
		"test":function(str){
			return this["expression"].test(str);
		},
		"grab":function(s){
			if(modifier.indexOf("g")==-1&&!this.setGlobal){
				this["expression"]=new RegExp(str,(modifier||"")+"g");
				this.setGlobal=true;
			}
			return this["expression"].exec(s);
		},
		"grabAll":function(s){
			if(modifier.indexOf("g")==-1&&!this.setGlobal){
				this["expression"]=new RegExp(str,(modifier||"")+"g");
				this.setGlobal=true;
			}
			var rs=[];
			var tmp="";
			while(tmp=this["expression"].exec(s)){
				rs.push(tmp);
			}
			return rs;
		}
	}
}
String.prototype["matchCN"]=function(str,modifier){
	var tmp=RegExpCN(str,modifier).expression;
	var r=this.match(tmp);
	return r;
};
String.prototype["matchAllCN"]=function(str,ic){
	/*
		alert("aaaab456bbccccb123b".ƥȫ("b($1-)(b)","i"));
	*/
	var rs=[];
	if(ic!==false){ic=true;}
	var tmp=RegExpCN(str,ic?"gi":"g").expression;
	var tmp2=RegExpCN(str,ic?"i":"").expression;
	var matches=this.match(tmp);
	if(matches){
		for(var i=0,l=matches.length;i<l;i++){
			rs[i]=matches[i].match(tmp2);
		}
		return rs;
	}else{
		return null;
	}
};
String.prototype["replaceCN"]=function(str,arg,modifier){
	/*
		var x="aaaaab456123baaaac";
		x = x.滻("[a]1-","","gi")
	*/
	if(modifier!==""){modifier="gi"}
	var tmp=RegExpCN(str,modifier).expression;
	return this.replace(tmp,arg);
};
String.prototype["repeat"]=function(nn){
	if(!nn&&nn!==0) nn=1;
	var str="";
	for(var i=0;i<nn;i++){
		str+=this;
	}
	return str;
};
String.prototype["random"]=function(n){
	/*
	alert("nscb".(8));
	*/
	return $R(n,this);
};
String.prototype["reverse"]=function(){
	return this.split("").reverse().join("");
};
String.prototype["show"]=function(n,end){
	if(this.length<=n){
		return this;
	}else{
		return this.substring(0,n)+end||"";
	}
};
function arr2str(arr,n,is_array){
	if(!n){n=0;}
	var str="[\r\n";
	var tmp=[];
	for(var i=0;i<arr.length;i++){
		var ot=$Y(arr[i]);
		var rt="\t".repeat(n);
		var suffix="\""+i+"\":";
		if(is_array){
			suffix="";
		}
		switch(ot){
			case "object":
				tmp.push(rt+suffix+obj2str(arr[i],n+1));
				break;
			case "null":
				tmp.push(rt+suffix+"null");
				break;
			case "array":
				tmp.push(rt+suffix+arr2str(arr[i],n+1,true));
				break;
			case "function":
			case "number":
				tmp.push(rt+suffix+arr[i].toString());
				break;
			case "undefined":
				tmp.push(rt+suffix+"undefined");
				break;
			case "boolean":
				tmp.push(rt+suffix+obj[i].toString());
				break;
			default:
				tmp.push(rt+suffix+"\""+arr[i].toString().replace(/"/g,"\\\"")+"\"");
		}
	}
	str+=tmp.join(",\r\n");
	return str+"\r\n"+"\t".repeat(n-1)+"]";
}
function obj2str(obj,n,is_array){
	if(!n){n=0;}
	var str="{\r\n";
	var tmp=[];
	for(var i in obj){
		var ot=$Y(obj[i]);
		var rt="\t".repeat(n);
		var suffix="\""+i+"\":";
		if(is_array){
			suffix="";
		}
		switch(ot){
			case "object":
				tmp.push(rt+suffix+obj2str(obj[i],n+1));
				break;
			case "null":
				tmp.push(rt+suffix+"null");
				break;
			case "array":
				tmp.push(rt+suffix+arr2str(obj[i],n+1,true));
				break;
			case "function":
			case "number":
				tmp.push(rt+suffix+obj[i].toString());
				break;
			case "undefined":
				tmp.push(rt+suffix+"undefined");
				break;
			case "boolean":
				tmp.push(rt+suffix+obj[i].toString());
				break;
			default:
				tmp.push(rt+suffix+"\""+obj[i].toString().replace(/"/g,"\\\"")+"\"");
		}
	}
	str+=tmp.join(",\r\n");
	return str+"\r\n"+"\t".repeat(n-1)+"}";
}
/*Gcolor table , From GnJs Project*/
function Gcolortable_click(panel,color){
	$(Dom.Html.attr(panel,"colortext")).value=color;
	Dom.Html.hid(panel);
	var pk=$(Dom.Html.attr("TOOLMAO_colorPanel","colorpicker"));
	pk.style.background=color;
	pk.setAttribute("title",color);
}
function Gcolortable_over(panel,color){
	$(Dom.Html.attr(panel,"colortext")).value=color;
}
function Gcolortable(){
     var colorW=21,colorH=12;
     var carr=["00","33","66","99","CC","FF"];
     var leftColor=["000000","333333","666666","999999","cccccc","FFFFFF","FF0000","00FF00","0000FF","FFFF00","00FFFF","FF00FF"];
     var colorTab=[];
     var tmpcolor="";
     this.colortext="";
     this.colorpanel="";
     this.colorpicker="";
     this.create=function(type){
		 var that=this;
         function createTable(){
			 var tbstr=[];
             tbstr.push("<table cellspacing='0' cellpadding='0' style='font-size:0pt;border:0px none #fff;background:#000'>");
             for(var i=0;i<colorH;i++){
				tbstr.push("<tr height='12'>");
				for(var j=0;j<colorW;j++){
					 var tdcolor="#"+colorTab[j+i*colorW];
					 tbstr.push("<td onclick='Gcolortable_click(\""+that.colorpanel+"\",\""+tdcolor+"\")' onmouseover='Gcolortable_over(\""+that.colorpanel+"\",\""+tdcolor+"\")' title='"+tdcolor+"' style='background:"+tdcolor+";"+((i==0)?"":"border-top:none;")+((j==0)?"":"border-left:none;")+"' class='colortable'></td>");
                 }
                 tbstr.push("</tr>");
             }
             tbstr.push("</table>");
             return tbstr.join("");
         }
         function createColorCube(){
             colorTab=["000000","000000","000000","000000","003300","006600","009900","00CC00","00FF00","330000","333300","336600","339900","33CC00","33FF00","660000","663300","666600","669900","66CC00","66FF00","000000","333333","000000","000033","003333","006633","009933","00CC33","00FF33","330033","333333","336633","339933","33CC33","33FF33","660033","663333","666633","669933","66CC33","66FF33","000000","666666","000000","000066","003366","006666","009966","00CC66","00FF66","330066","333366","336666","339966","33CC66","33FF66","660066","663366","666666","669966","66CC66","66FF66","000000","999999","000000","000099","003399","006699","009999","00CC99","00FF99","330099","333399","336699","339999","33CC99","33FF99","660099","663399","666699","669999","66CC99","66FF99","000000","cccccc","000000","0000CC","0033CC","0066CC","0099CC","00CCCC","00FFCC","3300CC","3333CC","3366CC","3399CC","33CCCC","33FFCC","6600CC","6633CC","6666CC","6699CC","66CCCC","66FFCC","000000","FFFFFF","000000","0000FF","0033FF","0066FF","0099FF","00CCFF","00FFFF","3300FF","3333FF","3366FF","3399FF","33CCFF","33FFFF","6600FF","6633FF","6666FF","6699FF","66CCFF","66FFFF","000000","FF0000","000000","990000","993300","996600","999900","99CC00","99FF00","CC0000","CC3300","CC6600","CC9900","CCCC00","CCFF00","FF0000","FF3300","FF6600","FF9900","FFCC00","FFFF00","000000","00FF00","000000","990033","993333","996633","999933","99CC33","99FF33","CC0033","CC3333","CC6633","CC9933","CCCC33","CCFF33","FF0033","FF3333","FF6633","FF9933","FFCC33","FFFF33","000000","0000FF","000000","990066","993366","996666","999966","99CC66","99FF66","CC0066","CC3366","CC6666","CC9966","CCCC66","CCFF66","FF0066","FF3366","FF6666","FF9966","FFCC66","FFFF66","000000","FFFF00","000000","990099","993399","996699","999999","99CC99","99FF99","CC0099","CC3399","CC6699","CC9999","CCCC99","CCFF99","FF0099","FF3399","FF6699","FF9999","FFCC99","FFFF99","000000","00FFFF","000000","9900CC","9933CC","9966CC","9999CC","99CCCC","99FFCC","CC00CC","CC33CC","CC66CC","CC99CC","CCCCCC","CCFFCC","FF00CC","FF33CC","FF66CC","FF99CC","FFCCCC","FFFFCC","000000","FF00FF","000000","9900FF","9933FF","9966FF","9999FF","99CCFF","99FFFF","CC00FF","CC33FF","CC66FF","CC99FF","CCCCFF","CCFFFF","FF00FF","FF33FF","FF66FF","FF99FF","FFCCFF","FFFFFF"];
             return createTable();
         }
         function createSeqCube(){
             colorW=21;colorH=12;
             var cCube=0,cCol=0;cRow=0;
             for(var i=0;i<colorW*colorH;i++){
                 if(i%21==0||i%21==2) colorTab[i]="000000";
                 else if(i%21==1) colorTab[i]=leftColor[(i-1)/21];
                 else{
                     cRow=Math.floor(i/21);cCol=(i-3)%21;
                     if(cCol<6) cCube=cRow>5?5:4;
                     else if(cCol>=6&&cCol<12) cCube=cRow>5?3:2;
                     else cCube=cRow>5?1:0;
                     cCol=(cCube==2||cCube==3)?cCol%6:(5-cCol%6);
                     cRow=(cCube==5||cCube==3||cCube==1)?cRow%6:(5-cRow%6);
                     colorTab[i]=carr[cCube]+carr[cRow]+carr[cCol];
                 }
             }
             return createTable();
         }
         function createBwCube(){
             colorW=21;colorH=13;
             for(var i=0;i<colorW*colorH;i++){
                 if(255-i>=0){
                     var sc=(255-i).toString(16);
                     if(sc.length==1) sc="0"+sc;
                     colorTab[i]=sc+sc+sc;
                 }
             else colorTab[i]="ffffff";
             }
             return createTable();
         }
         if(!type) type="";
         switch(type){
             case "":
				 var colors=createColorCube();
                 return colors;break;
             case "bw":
             case 2:
                 return createBwCube();break;
             case 1:
             case "seq":
                 return createSeqCube();break;
         }
     }
}